"use strict";
cc._RF.push(module, 'e1b90/rohdEk4SdmmEZANaD', 'Helloworld');
// Script/Helloworld.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Helloworld = /** @class */ (function (_super) {
    __extends(Helloworld, _super);
    function Helloworld() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.video = null;
        _this.gl = null;
        _this.texture = null;
        return _this;
    }
    Helloworld.prototype.onLoad = function () {
        this.video = document.createElement('video');
        this.gl = cc.renderer["device"]._gl;
        this.texture = new cc.Texture2D();
        this.texture.initWithData(new Uint8Array([0, 0, 0]), cc.Texture2D.PixelFormat.RGB888, 1, 1);
        this.node.addComponent(cc.Sprite).spriteFrame = new cc.SpriteFrame(this.texture);
    };
    Helloworld.prototype.update = function (dt) {
        this.accessWebCamera(this.video);
        this.updateTexture(this.gl, this.texture["_texture"], this.video);
    };
    Helloworld.prototype.updateTexture = function (gl, texture, video) {
        gl.bindTexture(gl.TEXTURE_2D, texture._glID);
        gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, video);
    };
    Helloworld.prototype.accessWebCamera = function (video) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var mediaConstraints = { audio: false, video: {
                    width: _this.node.width,
                    height: _this.node.height,
                    brightness: { ideal: 2 }
                }
            };
            navigator.mediaDevices.getUserMedia(mediaConstraints).then(function (mediaStream) {
                video.srcObject = mediaStream;
                video.setAttribute('play_video', true);
                video.onloadedmetadata = function (e) {
                    video.play();
                    resolve(video);
                };
            }).catch(function (err) {
                reject(err);
            });
        });
    };
    Helloworld = __decorate([
        ccclass
    ], Helloworld);
    return Helloworld;
}(cc.Component));
exports.default = Helloworld;

cc._RF.pop();